//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  DeepSkyBlue
#property indicator_color2  DeepSkyBlue
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DimGray
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_level1  0
#property indicator_levelcolor DimGray

//
//
//
//
//

extern string TimeFrame   = "current time frame";
extern int    Length      = 25;
extern int    FastLength  = 25;
extern int    Price       = PRICE_CLOSE;
extern bool   Interpolate = true;

double osc[];
double oscuu[];
double oscud[];
double oscdd[];
double oscdu[];
double price[];
double slope[];
double retracing[];

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,oscuu); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,oscud); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,oscdd); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,oscdu); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,osc);
      SetIndexBuffer(5,price);
      SetIndexBuffer(6,slope);
      SetIndexBuffer(7,retracing);
         Length     = MathMax(Length,2);
         FastLength = MathMax(MathMin(FastLength,Length),2);

         //
         //
         //
         //
         //
                  
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         
         //
         //
         //
         //
         //
   
   IndicatorShortName(timeFrameToString(timeFrame)+" Simple oscillator 3 ("+Length+","+FastLength+")");
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int n,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { oscuu[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      for(int i=limit; i>=0; i--)
      {
         price[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         osc[i]   = 0;

            int length = MathMax(Length-retracing[i+1],FastLength);
            double weight = (length-1.0)/2.0;  for (int k=0; k<length; k++, weight -= 1) osc[i] += price[i+k]*weight;

            //
            //
            //
            //
            //
            
            oscuu[i] = EMPTY_VALUE;
            oscud[i] = EMPTY_VALUE;
            oscdd[i] = EMPTY_VALUE;
            oscdu[i] = EMPTY_VALUE;
            slope[i] = slope[i+1];
            retracing[i] = retracing[i+1];
               if (osc[i]>osc[i+1]) slope[i]= 1;
               if (osc[i]<osc[i+1]) slope[i]=-1;
               if (osc[i]>0 && slope[i]== 1) { oscuu[i] = osc[i]; retracing[i] -= 1; }
               if (osc[i]>0 && slope[i]==-1) { oscud[i] = osc[i]; retracing[i] += 1; }
               if (osc[i]<0 && slope[i]==-1) { oscdd[i] = osc[i]; retracing[i] -= 1; }
               if (osc[i]<0 && slope[i]== 1) { oscdu[i] = osc[i]; retracing[i] += 1; }
                                                                  retracing[i] = MathMax(retracing[i],0);
      }
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         osc[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,FastLength,Price,4,y);
         slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,FastLength,Price,6,y);

         //
         //
         //
         //
         //
      
            oscuu[i] = EMPTY_VALUE;
            oscud[i] = EMPTY_VALUE;
            oscdd[i] = EMPTY_VALUE;
            oscdu[i] = EMPTY_VALUE;
               if (osc[i]>0 && slope[i]== 1) oscuu[i] = osc[i];
               if (osc[i]>0 && slope[i]==-1) oscud[i] = osc[i];
               if (osc[i]<0 && slope[i]==-1) oscdd[i] = osc[i];
               if (osc[i]<0 && slope[i]== 1) oscdu[i] = osc[i];
               if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; k < n; k++)
            {
               osc[i+k] = osc[i] + (osc[i+n]-osc[i])*k/n;
               if (oscuu[i+k]!=EMPTY_VALUE) oscuu[i+k]=osc[i+k];
               if (oscud[i+k]!=EMPTY_VALUE) oscud[i+k]=osc[i+k];
               if (oscdu[i+k]!=EMPTY_VALUE) oscdu[i+k]=osc[i+k];
               if (oscdd[i+k]!=EMPTY_VALUE) oscdd[i+k]=osc[i+k];
            }
   }
   return(0);         
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}